%%%%%%%%%%%%%%%%%%%%%%%%%%%%% -*- Mode: Prolog -*- %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% morpho.pl --- 
%% Author          : Massimo Fasciano
%% Last Modified On: Wed Oct 20 22:04:35 1993
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% an extremely simple morphological unit to test the output
% from PFUF.

morpho([],[]).
morpho([...|FDs],[...|FDs2]) :- !,morpho(FDs,FDs2).
morpho([FD|FDs],[Lex|Lexs]) :-
    lex(FD,Lex),!,morpho(FDs,Lexs).
morpho([FD|FDs],Lexs) :- morpho(FDs,Lexs).

val(FD,F,Val) :- unif(FD,[F:Val0|_]),nonvar(Val0),Val=Val0.

lex(FD,Lex) :-
    val(FD,lex,Lex0), !,
    (val(FD,cat,Cat),
     (Cat = verb,
      (val(FD,ending,past_participle), past_participle(Lex0,Lex);
       unif([number:N|_],FD), present(Lex0,N,Lex));
      Cat = noun, val(FD,number,plural), !, plural(Lex0,Lex));
     Lex = Lex0).
     
termine(X,Term,Lex) :-
    name(X,L),name(Term,TermL),conc(L,TermL,PL),name(Lex,PL).

d_present(be,singular,is).
d_present(be,plural,are).
present(X,N,Y) :- d_present(X,N,Y),!.
present(X,singular,Y) :- termine(X,s,Y),!.
present(X,plural,X).

d_past_participle(_,_) :- !,fail.     %% pour Quintus

past_participle(X,Y) :- d_past_participle(X,Y),!.
past_participle(X,Y) :- termine(X,n,Y).

d_plural(man,men).
plural(X,Y) :- d_plural(X,Y),!.
plural(X,Y) :- termine(X,s,Y).

writePattern([]).
writePattern([...|R]) :- !,writePattern(R).
writePattern([X|R]) :- write(X),write(' '),writePattern(R).
