%%%%%%%%%%%%%%%%%%%%%%%%%%%%% -*- Mode: Prolog -*- %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% punif.pl --- Pattern Unifier
%% Author          : Michel Gagnon
%% Last Modified On: Tue Jul 21 22:51:50 1992
%% Update Count    : 5
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

punif(X,Y,Z) :-
    unifier(X,Y,Z).

% Unification de deux patterns.
% Le code "..." peut etre unifier avec n'importe quelle
% suite d'items.
unifier([],[],[]).
unifier(X,[...],X).
unifier([...],X,X):-
	X \== '...'.
unifier([...,X|R1],[...,X|R2],[...,X|R3]):-
	unifier(R1,R2,R3).
unifier([...,X|R1],[...,Y|R2],[...,X|R3]):-
	X \== Y,
	\+ member(X,R2),
	unifier(R1,[...,Y|R2],R3).
unifier([...,X|R1],[...,Y|R2],[...,Y|R3]):-
	X \== Y,
	\+ member(Y,R1),
	unifier([...,X|R1],R2,R3).
unifier([...,X|R1],[Y|R2],[Y|R3]):-
	Y \== ...,
	X \== Y,
	\+ member(Y,R1),
	unifier([...,X|R1],R2,R3).
unifier([X|R1],[...,Y|R2],[X|R3]):-
	X \== ...,
	X \== Y,
	\+ member(X,R2),
	unifier(R1,[...,Y|R2],R3).
unifier([...,X|R1],[X|R2],[X|R3]):-
	X \== ...,
	unifier(R1,R2,R3).
unifier([X|R1],[...,X|R2],[X|R3]):-
	X \== ...,
	unifier(R1,R2,R3).
unifier([X|R1],[X|R2],[X|R3]):-
	X \== ...,
	unifier(R1,R2,R3).
